> This page is for Cash App Pay Partner API.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.cash.app/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.cash.app/_mcp/server.

# List refunds

GET https://api.cash.app/network/v1/refunds

Returns a list of refunds matching the given query parameters.

**This endpoint is rate limited to 100 QPS.**

Scopes: `REFUNDS_READ`

Reference: https://developers.cash.app/cash-app-pay-partner-api/api-reference/network-api/list-refunds

## Servers

- `https://api.cash.app/network/v1` (Production, default)
- `https://sandbox.api.cash.app/network/v1` (Sandbox)

## Request

### Query parameters

- `cursor` (string, optional) — A pagination cursor returned by a previous call to this endpoint. Provide this cursor to retrieve the next set of results for the original query.
- `reference_id` (string, optional) — Filters results to only include refunds with a `reference_id` matching the given value.
- `customer_id` (string, optional) — Filters results to only include refunds made to a customer that matches the the given ID.
- `merchant_id` (string, optional) — Filters results to only include refunds made by a merchant that matches the given ID.
- `limit` (integer, optional, default: 50) — Maximum number of refunds to return.

## Response

### 200

OK

- `refunds` (list of Refund, required) — List of refunds matching the given query parameters.
- `cursor` (string, optional) — The pagination cursor to be used in a subsequent request. If empty, this is the final response.

## Errors

### 400 List Refunds Request Bad Request Error

Bad Request

- `errors` (list of Error, required) — A list of errors that occurred while processing the request. Min number of items: `1`

## Types

### Refund

- `id` (string, required) — Unique identifier for this refund issued by Cash App. Min length: `1` Max length: `128`
- `amount` (integer, required) — Amount of money to refund, in the lowest denomination of currency on the refund. Min value: `1`
- `currency` (enum, required) — Indicates the country associated with an entity. Values are from the [ISO-4217 Alpha-3](https://www.iso.org/iso-4217-currency-codes.html) specification. Current values: - `USD`: United States Dollar
  - Allowed values: `USD`
- `customer_id` (string, required) — ID of the customer that received this refund. Min length: `1` Max length: `128`
- `merchant_id` (string, required) — ID of the merchant that issued this refund. Min length: `1` Max length: `128`
- `status` (enum, required) — The step of the refund processing lifecycle that this refund is currently at. - `AUTHORIZED` - `CAPTURED` - `VOIDED` - `DECLINED`
  - Allowed values: `AUTHORIZED`, `CAPTURED`, `VOIDED`, `DECLINED`
- `created_at` (datetime, required) — When this refund was created, in [RFC 3339](https://datatracker.ietf.org/doc/html/rfc3339) format (UTC).
- `updated_at` (datetime, required) — When this refund was last updated, in [RFC 3339](https://datatracker.ietf.org/doc/html/rfc3339) format (UTC).
- `grant_id` (string, optional) — This is currently unused and empty. Min length: `1` Max length: `256`
- `payment_id` (string, optional) — This is currently unused and empty. Min length: `1` Max length: `128`
- `reference_id` (string, optional) — A user-defined identifier for this refund, typically used to associate the refund with a record in an external system. Min length: `1` Max length: `1024`
- `metadata` (map from string to string, optional) — Freeform key-value pairs of arbitrary data associated with this resource. Keys and values must be passed as strings and not contain any personally identifiable information (PII). Min keys: `0` Max keys: `50` > Note: Nested keys are not supported.
- `decline_errors` (list of Error, optional) — If the refund was declined, contains a list of the reasons why it was declined. Min number of items: `1`

### Error

Represents an error encountered during a request to the API.

- `category` (enum, required) — The high-level reason the error occurred.
  - Allowed values: `API_ERROR`, `AUTHENTICATION_ERROR`, `BRAND_ERROR`, `DISPUTE_ERROR`, `MERCHANT_ERROR`, `INVALID_REQUEST_ERROR`, `PAYMENT_PROCESSING_ERROR`, `RATE_LIMIT_ERROR`, `WEBHOOK_ERROR`, `API_KEY_ERROR`, `GRANT_ERROR`
- `code` (string, required) — A unique identifier for the specific type of error that occurred. For more information, see [Error Code Reference](/cash-app-pay-partner-api/guides/technical-guides/api-fundamentals/errors/error-code-reference). Min length: `1`
- `detail` (string, optional) — Human-readable description of why the error occurred and how to resolve it. Min length: `1`
- `field` (string, optional) — The field in the request that caused the error, using array and object dot notation. Min length: `1`

## Examples

**Response**

```json
{
  "refunds": [
    {
      "id": "PWCR_da1v3j4p3z15y47adpzzq0whj",
      "amount": 2500,
      "currency": "USD",
      "customer_id": "CST_AQmxh4y_QGoNNIG5NUw0jttqyYedL1LklACQdyJ3H-Vs6WmLtP6A_C7XjQNohvY",
      "merchant_id": "MMI_4vxs5egfk7hmta3qx2h6rp91x",
      "status": "AUTHORIZED",
      "created_at": "2022-01-01T12:00:00Z",
      "updated_at": "2022-01-05T12:00:00Z",
      "grant_id": "GRG_221243dc6985a6819ff6950c1a21332f7bc4a46ebd49b5a7002908ab768e8e5ff7831e084d0d2c9d8d939793b55eff50",
      "payment_id": "PWC_4nn21zy6t0v2yhqg5bvhk7xkq",
      "reference_id": "external-id",
      "metadata": {
        "key": "value"
      },
      "decline_errors": [
        {
          "category": "INVALID_REQUEST_ERROR",
          "code": "MISSING_REQUIRED_FIELD",
          "detail": "Missing required parameter.",
          "field": "field_a[2].field_b"
        }
      ]
    }
  ],
  "cursor": "cursor"
}
```

**SDK Code**

```python
import requests

url = "https://api.cash.app/network/v1/refunds"

querystring = {"customer_id":"AUTH_24g7nq7m1je9b6fnzbtvwzqej","merchant_id":"MMI_4vxs5egfk7hmta3qx2h6rp91x","reference_id":"external-id"}

response = requests.get(url, params=querystring)

print(response.json())
```

```javascript
const url = 'https://api.cash.app/network/v1/refunds?customer_id=AUTH_24g7nq7m1je9b6fnzbtvwzqej&merchant_id=MMI_4vxs5egfk7hmta3qx2h6rp91x&reference_id=external-id';
const options = {method: 'GET'};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.cash.app/network/v1/refunds?customer_id=AUTH_24g7nq7m1je9b6fnzbtvwzqej&merchant_id=MMI_4vxs5egfk7hmta3qx2h6rp91x&reference_id=external-id"

	req, _ := http.NewRequest("GET", url, nil)

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.cash.app/network/v1/refunds?customer_id=AUTH_24g7nq7m1je9b6fnzbtvwzqej&merchant_id=MMI_4vxs5egfk7hmta3qx2h6rp91x&reference_id=external-id")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.cash.app/network/v1/refunds?customer_id=AUTH_24g7nq7m1je9b6fnzbtvwzqej&merchant_id=MMI_4vxs5egfk7hmta3qx2h6rp91x&reference_id=external-id")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.cash.app/network/v1/refunds?customer_id=AUTH_24g7nq7m1je9b6fnzbtvwzqej&merchant_id=MMI_4vxs5egfk7hmta3qx2h6rp91x&reference_id=external-id');

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.cash.app/network/v1/refunds?customer_id=AUTH_24g7nq7m1je9b6fnzbtvwzqej&merchant_id=MMI_4vxs5egfk7hmta3qx2h6rp91x&reference_id=external-id");
var request = new RestRequest(Method.GET);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let request = NSMutableURLRequest(url: NSURL(string: "https://api.cash.app/network/v1/refunds?customer_id=AUTH_24g7nq7m1je9b6fnzbtvwzqej&merchant_id=MMI_4vxs5egfk7hmta3qx2h6rp91x&reference_id=external-id")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```